import { Holder } from './Holder.js';
import { Identifier } from './Identifier.js';
export declare class Registry<T> {
    readonly key: Identifier;
    private readonly parser?;
    static readonly REGISTRY: Registry<Registry<unknown>>;
    private readonly storage;
    private readonly builtin;
    constructor(key: Identifier, parser?: ((obj: unknown) => T) | undefined);
    register(id: Identifier, value: T, builtin?: boolean): Holder<T>;
    delete(id: Identifier): boolean;
    keys(): Identifier[];
    has(id: Identifier): boolean;
    get(id: Identifier): T | undefined;
    getOrThrow(id: Identifier): T & ({} | null);
    parse(obj: unknown): T;
    clear(): this;
    assign(other: Registry<T>): this;
    cloneEmpty(): Registry<T>;
    forEach(fn: (key: Identifier, value: T, registry: Registry<T>) => void): void;
    map<U>(fn: (key: Identifier, value: T, registry: Registry<T>) => U): U[];
}
//# sourceMappingURL=Registry.d.ts.map