import type { quat } from 'gl-matrix';
import { mat4 } from 'gl-matrix';
import { Vector } from './Vector.js';
export declare class Matrix4 {
    data: mat4;
    constructor(data?: mat4);
    static fromQuat(source: quat): Matrix4;
    clone(): Matrix4;
    translate(a: Vector | [number, number, number]): this;
    scale(a: Vector | [number, number, number] | number): this;
    add(other: Matrix4): this;
    sub(other: Matrix4): this;
    mul(other: Matrix4): this;
    transpose(): this;
    invert(): this;
    affine(): this;
    get m00(): number;
    get m01(): number;
    get m02(): number;
    get m03(): number;
    get m10(): number;
    get m11(): number;
    get m12(): number;
    get m13(): number;
    get m20(): number;
    get m21(): number;
    get m22(): number;
    get m23(): number;
    get m30(): number;
    get m31(): number;
    get m32(): number;
    get m33(): number;
    set m00(x: number);
    set m01(x: number);
    set m02(x: number);
    set m03(x: number);
    set m10(x: number);
    set m11(x: number);
    set m12(x: number);
    set m13(x: number);
    set m20(x: number);
    set m21(x: number);
    set m22(x: number);
    set m23(x: number);
    set m30(x: number);
    set m31(x: number);
    set m32(x: number);
    set m33(x: number);
    getTranslation(): Vector;
    toString(): string;
}
//# sourceMappingURL=Matrix4.d.ts.map