import { Json } from '../util/index.js';
export var VerticalAnchor;
(function (VerticalAnchor) {
    function fromJson(obj) {
        const root = Json.readObject(obj) ?? {};
        if (root.absolute !== undefined) {
            return absolute(Json.readNumber(root.absolute) ?? 0);
        }
        else if (root.above_bottom !== undefined) {
            return aboveBottom(Json.readNumber(root.above_bottom) ?? 0);
        }
        else if (root.below_top !== undefined) {
            return belowTop(Json.readNumber(root.below_top) ?? 0);
        }
        return () => 0;
    }
    VerticalAnchor.fromJson = fromJson;
    function absolute(value) {
        return () => value;
    }
    function aboveBottom(value) {
        return context => context.minY + value;
    }
    function belowTop(value) {
        return context => context.maxY - value;
    }
})(VerticalAnchor || (VerticalAnchor = {}));
export var WorldgenContext;
(function (WorldgenContext) {
    function create(minY, height) {
        return {
            minY,
            height,
            maxY: minY + height - 1,
        };
    }
    WorldgenContext.create = create;
})(WorldgenContext || (WorldgenContext = {}));
//# sourceMappingURL=VerticalAnchor.js.map